#include "Arduino.h"

#define LEDstripRED 11               // Referente ao pino Vermelho da Fita de Leds
#define LEDstripGREEN 9              // Referente ao pino Verde da Fita de Leds
#define LEDstripBLUE 10              // Referente ao pino Azul da Fita de Leds
#define SOUND 2                      // Referente à entrada do Sensor de Intensidade Sonora. Deve ser 2 ou 3 em função do uso de interrupção (para arduino Arduino Uno)
#define offDelay 5                   // Delay de varredura quando soundState está em nível lógico alto  (ligado/colorido)
#define onDelay 10           // Delay de varredura quando soundState está em nível lógico baixo (apagado)
#define debouncingDelay 1            // Delay durante interrupção. 
#define colorChanging  250   // Velocidade da mudanaça de cores
#define intensityFraction 0.05

volatile int soundState = 0; // variável de comunicação de informações alteradas na interrupção
volatile int color1 = 0;  // Variáveis para controlar a cor da fita de led
volatile int color2 = 0;
volatile int color3 = 0;

void setup()
{
  pinMode(SOUND,         INPUT_PULLUP);   // iniciali000000zação de pino para interrupção
  pinMode(LEDstripRED,   OUTPUT);
  pinMode(LEDstripGREEN, OUTPUT);
  pinMode(LEDstripBLUE,  OUTPUT);
  attachInterrupt(digitalPinToInterrupt(SOUND), soundEvent , RISING);   // associar pino de interrupção (SOUND) e tipo de evento (CHANGE) com a função de tratamento (soundEvent)
  // Serial.begin(9600); // DEBUG SERIAL
}

void loop()
{
  for (int ii = 0; ii < colorChanging ; ii++) {
    if (soundState) {   // se o nível lógico da variável for 1, a fita de leds é acesa com uma cor
      analogWrite(LEDstripRED,   color1);
      analogWrite(LEDstripGREEN, color2);
      analogWrite(LEDstripBLUE,  color3);
      soundState = 0;
      delay(onDelay);
    }
    else {       // se o nível lógico da variável for 0, a fita de led recebe metade da intensidade
      analogWrite(LEDstripRED,   color1*intensityFraction);
      analogWrite(LEDstripGREEN, color2*intensityFraction);
      analogWrite(LEDstripBLUE,  color3*intensityFraction);
      delay(offDelay);
    }

  }
  color1 = random(255);  // Variam randomicamente a cor da fita de leds
  color2 = random(255);
  color3 = random(255);
  //soundState=0;
}

void soundEvent () { // função de tratamento de interrupção
  soundState = !soundState; // inverte sinal lógico
  // Serial.println("int"); // DEBUG SERIAL
  delay(debouncingDelay);
}
